import * as z from 'zod';
import type { Prisma } from '../../../generated/prisma';
import { PaymentStatusSchema } from '../enums/PaymentStatus.schema';
import { ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInput.schema';
import { ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema as ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema } from './ServiceLineUncheckedCreateNestedManyWithoutPaymentInput.schema';
import { CommissionBatchItemUncheckedCreateNestedManyWithoutPaymentInputObjectSchema as CommissionBatchItemUncheckedCreateNestedManyWithoutPaymentInputObjectSchema } from './CommissionBatchItemUncheckedCreateNestedManyWithoutPaymentInput.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';

import Decimal from "decimal.js";
const makeSchema = () => z.object({
  id: z.number().int().optional(),
  claimId: z.number().int().optional().nullable(),
  userId: z.number().int(),
  updatedById: z.number().int().optional().nullable(),
  npiProviderId: z.number().int().optional().nullable(),
  totalBilled: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalBilled' must be a Decimal",
}),
  totalPaid: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalPaid' must be a Decimal",
}).optional(),
  totalAdjusted: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalAdjusted' must be a Decimal",
}).optional(),
  totalDue: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalDue' must be a Decimal",
}),
  mhPaidAmount: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'mhPaidAmount' must be a Decimal",
}).optional().nullable(),
  copayment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'copayment' must be a Decimal",
}).optional(),
  adjustment: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'adjustment' must be a Decimal",
}).optional(),
  status: PaymentStatusSchema.optional(),
  notes: z.string().optional().nullable(),
  icn: z.string().optional().nullable(),
  createdAt: z.coerce.date().optional(),
  updatedAt: z.coerce.date().optional(),
  serviceLineTransactions: z.lazy(() => ServiceLineTransactionUncheckedCreateNestedManyWithoutPaymentInputObjectSchema).optional(),
  serviceLines: z.lazy(() => ServiceLineUncheckedCreateNestedManyWithoutPaymentInputObjectSchema).optional(),
  commissionBatchItems: z.lazy(() => CommissionBatchItemUncheckedCreateNestedManyWithoutPaymentInputObjectSchema).optional()
}).strict();
export const PaymentUncheckedCreateWithoutPatientInputObjectSchema: z.ZodType<Prisma.PaymentUncheckedCreateWithoutPatientInput> = makeSchema() as unknown as z.ZodType<Prisma.PaymentUncheckedCreateWithoutPatientInput>;
export const PaymentUncheckedCreateWithoutPatientInputObjectZodSchema = makeSchema();
